Proxmox/setup/node-red-install.sh

137 lines
3.4 KiB
Bash
Raw Normal View History

2022-04-25 17:16:28 +02:00
#!/usr/bin/env bash
2022-04-18 20:44:52 +02:00
YW=`echo "\033[33m"`
2022-02-23 12:56:52 +01:00
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"`
CL=`echo "\033[m"`
2022-03-11 04:25:22 +01:00
RETRY_NUM=10
2022-02-23 12:56:52 +01:00
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-18 20:44:52 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
local reason="Unknown failure occurred."
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-18 20:44:52 +02:00
function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
2022-04-16 13:33:50 +02:00
2022-04-18 20:44:52 +02:00
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
2022-08-31 11:20:58 +02:00
function msg_error() {
local msg="$1"
echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
}
2022-04-18 20:44:52 +02:00
msg_info "Setting up Container OS "
2022-02-23 12:56:52 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
2022-08-31 11:20:58 +02:00
1>&2 echo -en "${CROSS}${RD} No Network! "
2022-02-23 12:56:52 +01:00
sleep $RETRY_EVERY
((NUM--))
if [ $NUM -eq 0 ]
then
2022-08-31 11:20:58 +02:00
1>&2 echo -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
2022-02-23 12:56:52 +01:00
exit 1
fi
done
2022-04-18 20:44:52 +02:00
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-02-23 12:56:52 +01:00
set +e
alias die=''
2022-08-31 11:20:58 +02:00
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; else msg_error "Internet NOT Connected"; exit 1; fi;
RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi;
alias die='EXIT=$? LINE=$LINENO error_exit'
set -e
2022-08-31 11:20:58 +02:00
2022-04-18 20:44:52 +02:00
msg_info "Updating Container OS"
2022-08-30 00:43:55 +02:00
apt-get update &>/dev/null
apt-get -y upgrade &>/dev/null
2022-04-18 20:44:52 +02:00
msg_ok "Updated Container OS"
2022-02-23 12:56:52 +01:00
2022-04-18 20:44:52 +02:00
msg_info "Installing Dependencies"
2022-02-23 12:56:52 +01:00
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
2022-04-18 20:44:52 +02:00
msg_ok "Installed Dependencies"
2022-02-23 12:56:52 +01:00
msg_info "Setting up Node.js Repository"
curl -fsSL https://deb.nodesource.com/setup_18.x | bash - &>/dev/null
msg_ok "Set up Node.js Repository"
msg_info "Installing Node.js"
apt-get install -y nodejs &>/dev/null
msg_ok "Installed Node.js"
2022-04-18 20:44:52 +02:00
msg_info "Installing Node-Red"
npm install -g --unsafe-perm node-red &>/dev/null
2022-04-18 20:44:52 +02:00
msg_ok "Installed Node-Red"
2022-02-23 12:56:52 +01:00
msg_info "Creating Service"
service_path="/etc/systemd/system/nodered.service"
echo "[Unit]
Description=Node-RED
After=syslog.target network.target
[Service]
ExecStart=/usr/bin/node-red --max-old-space-size=128 -v
Restart=on-failure
KillSignal=SIGINT
SyslogIdentifier=node-red
StandardOutput=syslog
WorkingDirectory=/root/
User=root
Group=root
[Install]
WantedBy=multi-user.target" > $service_path
systemctl enable --now nodered.service &>/dev/null
msg_ok "Created Service"
2022-03-08 15:57:10 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
2022-04-18 20:44:52 +02:00
msg_info "Customizing Container"
2022-02-23 12:56:52 +01:00
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat << EOF > $GETTY_OVERRIDE
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
2022-04-18 20:44:52 +02:00
msg_ok "Customized Container"
2022-03-08 15:57:10 +01:00
fi
2022-04-18 20:44:52 +02:00
msg_info "Cleaning up"
2022-02-23 12:56:52 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
2022-04-18 20:44:52 +02:00
msg_ok "Cleaned"